SystemOrganization addCategory: #'GT-SUnitDebugger'!

DebugSession subclass: #GTSUnitDebugSession
	instanceVariableNames: 'assertionContext expectedResult actualResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugSession class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:24'!
activationPredicate

	^  GTSUnitActivationPredicate new! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:08'!
actualResult
	
	^ actualResult! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:08'!
expectedResult
	
	^ expectedResult! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/17/2013 11:12'!
isActive

	^ self isActive: self testContext! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/17/2013 11:11'!
isActive: aContext

	^ aContext 
		ifNil: [ false ] 
		ifNotNil: [ 
			aContext isDead not and: [
				aContext ~= self process suspendedContext or: [aContext willReturn not ] ] ]! !

!GTSUnitDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 12/17/2013 11:08'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	assertionContext ifNil: [
		assertionContext := aContext findContextMatchingPredicate: self class activationPredicate.
		actualResult := assertionContext tempAt: 1.
		expectedResult := assertionContext tempAt: 2]! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 13:02'!
testContext

	^ assertionContext sender! !

ContextPredicate subclass: #GTSUnitActivationPredicate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitActivationPredicate methodsFor: 'testing' stamp: 'AndreiChis 12/4/2013 12:19'!
matchContext: aContext
	
	^ aContext selector == #assert:equals:! !

TestCase subclass: #GTSUnitExampleFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitExampleFailingTest class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/29/2013 17:41'!
isUnitTest
	^ false! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 12/4/2013 11:19'!
testFailingDate
	|aDateAndTime|
	
	aDateAndTime :=  DateAndTime localTimeZone: TimeZone default; dosEpoch.
	self assert: (aDateAndTime offset: '0:12:00:00')  equals: '1980-01-01T13:00:00+12:00' asDateAndTime! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 12/29/2013 18:28'!
testFailingText

	self assert: 'I like pie  
pizza pie 
apple pie 
rad squared pi 
and other PIes'
	equals: 'I like pie  
pizza pie 
potato pie 
rad squared pi 
and other PIes'! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 12/17/2013 10:50'!
testMultiValuedStreaming
	| headers keysAndValues |
	headers := ZnHeaders new.
	headers at: 'Set-Cookie' put: 'foo=1'.
	headers at: 'Set-Cookie' add: 'bar=1'.
	headers at: 'Content-TYPE' put: 'text/plain'.
	headers at: 'Content-Length' put: '128'.
	keysAndValues := OrderedCollection streamContents: [ : stream |
		headers headersDo: [ :key :value |
			stream nextPut: key; nextPut: value ] ].
	self assert: keysAndValues equals: #('Set-Cookie' 'foo=1' 'Set-Cookie' 'bar=1' 'Content-Length' '128' 'Content-TYPE' 'text/plain') asOrderedCollection 
	
	! !

GTGenericStackDebugger subclass: #GTSUnitDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:07'!
defaultTitle

	^ 'SUnit Debugger'! !

!GTSUnitDebugger class methodsFor: 'testing' stamp: 'AndreiChis 12/4/2013 12:33'!
handlesContext: aContext
	self flag: 'this should go to the superclass'.
	^ (aContext findContextMatchingPredicate: self sessionClass activationPredicate) notNil! !

!GTSUnitDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/4/2013 12:14'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 70.! !

!GTSUnitDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:14'!
sessionClass

	^ GTSUnitDebugSession! !

!GTSUnitDebugger methodsFor: 'building' stamp: 'TudorGirba 12/14/2013 11:14'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code span: 2 ];
		row: #diff.! !

!GTSUnitDebugger methodsFor: 'building' stamp: 'AndreiChis 12/17/2013 10:59'!
debuggerTransmissionsIn: browser

	browser transmit
		fromOutsideEntityPort;
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		fromOutsideEntityPort;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session testContext ].
	browser transmit
		from: #stack port: #selection;
		to: #code;
		andShow: [ :composite :aContext | self methodCodeIn: composite forContext: aContext ].
	browser transmit
		from: #stack port: #selection;
		to: #diff;
		andShow: [ :composite | 
			(self diffIn: composite) title: 'Actual vs. expected'.
			(self inspectorIn: composite) title: 'Inspector' ]
	! !

!GTSUnitDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/17/2013 11:13'!
diffIn: composite

	^ composite diff
			when: [ self session isActive ];
			display: [ { 
				self printCollection: self session actualResult asOrderedCollection. 
				self printCollection: self session expectedResult asOrderedCollection }]! !

!GTSUnitDebugger methodsFor: 'printing' stamp: 'AndreiChis 12/29/2013 16:31'!
printCollection: aCollection

	 ^ String streamContents: [ :out | 
			aCollection do: [ :each | 
				out 
					nextPutAll: each printString;
					nextPut: Character cr ]]! !

!GTSUnitDebugger methodsFor: 'updating' stamp: 'AndreiChis 12/17/2013 11:04'!
updateBrowser

	super updateBrowser.
	"The transmission will select the context of the test case. 
	This should only happen the first time."
	((self browser paneNamed: #stack) port: #selection) value: self session interruptedContext! !
